package kriptografija;

import java.awt.*;
import java.awt.event.*;
import java.io.File;
import java.io.IOException;
import java.math.BigDecimal;

import javax.swing.*;
import javax.swing.filechooser.FileFilter;

public class GUI extends JFrame implements ActionListener, ItemListener {

	private static final long serialVersionUID = 1L;
	
	File opis_jezika;
	Dokument tipican_dokument;
	
	Dokument tekst;	
	Dokument sifrat;
	Object[][][] kljuc;
	
	/*KOMPONENTE*/
	JFileChooser jFileChooser = new JFileChooser();

	//LEVO
	JTabbedPane jTabbedPaneLevo = new JTabbedPane();
	
	//LEVO - TAB VIGENER
	JPanel jPanelTabVigener = new JPanel();
	
	//LEVO - TAB VIGENER - GORE TEKST
	JPanel jPanelTekst = new JPanel();
	
	JTextArea jTextAreaTekst = new JTextArea();
	JScrollPane jScrollPaneTekst = new JScrollPane();
	JPanel jPanelTekstInfo = new JPanel();
	JTextArea jTextAreaTekstInfo = new JTextArea();
	JScrollPane jScrollPaneTekstInfo = new JScrollPane();	

	//LEVO - TAB VIGENER - CENTAR UPRAVLJANJE
	JPanel jPanelCentar = new JPanel();
	
	JLabel jLabelTekst = new JLabel();
	JButton jButtonTekstDodaj = new JButton();
	JButton jButtonTekstSifrat = new JButton();
	JButton jButtonTekstSnimi = new JButton();
	JButton jButtonTekstBrisi = new JButton();	
	JLabel jLabelKljuc = new JLabel();
	JTextField jTextFieldKljuc = new JTextField();
	JLabel jLabelSifrat = new JLabel();
	JButton jButtonSifratDodaj = new JButton();
	JButton jButtonSifratTekst = new JButton();
	JButton jButtonSifratSnimi = new JButton();	
	JButton jButtonSifratBrisi = new JButton();	
	
	//LEVO - TAB VIGENER - DOLE SIFRAT
	JPanel jPanelSifrat = new JPanel();
	
	JTextArea jTextAreaSifrat = new JTextArea();
	JScrollPane jScrollPaneSifrat = new JScrollPane();
	JPanel jPanelSifratInfo = new JPanel();
	JTextArea jTextAreaSifratInfo = new JTextArea();
	JScrollPane jScrollPaneSifratInfo = new JScrollPane();	
	
	//LEVO - TAB ANALIZA
	JPanel jPanelTabAnaliza = new JPanel();
	
	//LEVO - TAB ANALIZA - LEVO TEKST
	JPanel jPanelRezultati = new JPanel();
	
	JTextArea jTextAreaRezultati = new JTextArea();
	JScrollPane jScrollPaneRezultati = new JScrollPane();
	
	//LEVO - TAB ANALIZA - DESNO UPRAVLJANJE
	JPanel jPanelUpravljanje = new JPanel();
	
	JLabel jLabelOpseg = new JLabel();
	JPanel jPanelOpseg = new JPanel();
	JTextField jTextFieldOpseg1 = new JTextField();
	JTextField jTextFieldOpseg2 = new JTextField();	
	JButton jButtonDuzina = new JButton();
	JTextField jTextFieldDuzina = new JTextField();
	JButton jButtonKljuc = new JButton();
	JLabel jLabelRezultatKljuc = new JLabel();
	JTextField jTextFieldRezultatKljuc = new JTextField();
	JComboBox jComboBoxRezultatKljuc1 = new JComboBox();
	JComboBox jComboBoxRezultatKljuc2 = new JComboBox();
	JComboBox jComboBoxRezultatKljuc3 = new JComboBox();
	JComboBox jComboBoxRezultatKljuc4 = new JComboBox();
	JComboBox jComboBoxRezultatKljuc5 = new JComboBox();
	JComboBox jComboBoxRezultatKljuc6 = new JComboBox();
	JComboBox jComboBoxRezultatKljuc7 = new JComboBox();
	JComboBox jComboBoxRezultatKljuc8 = new JComboBox();
	JComboBox jComboBoxRezultatKljuc9 = new JComboBox();
	JComboBox jComboBoxRezultatKljuc10 = new JComboBox();
	JComboBox jComboBoxRezultatKljuc11 = new JComboBox();
	JComboBox jComboBoxRezultatKljuc12 = new JComboBox();
	JComboBox jComboBoxRezultatKljuc13 = new JComboBox();
	JComboBox jComboBoxRezultatKljuc14 = new JComboBox();
	JComboBox jComboBoxRezultatKljuc15 = new JComboBox();
	JComboBox jComboBoxRezultatKljuc16 = new JComboBox();	
	JTextArea jTextAreaRezultatKljucevi = new JTextArea();
	JScrollPane jScrollPaneRezultatKljucevi = new JScrollPane();	
	JLabel jLabelTest = new JLabel();
	JButton jButtonUporedi = new JButton();
	JButton jButtonBrisi = new JButton();	
		
	//DNO
	JPanel jPanelDno = new JPanel();
	
	JPanel jPanelKontrola = new JPanel();	
	JButton jButtonNotepad = new JButton();	
	JButton jButtonJezik = new JButton();
	JLabel jLabelJezik = new JLabel();
	JProgressBar jProgressBar = new JProgressBar();
	/*KOMPONENTE KRAJ*/
	
	public GUI () {
		//PODESAVANJE FRAME-A
		addWindowListener(wl);
		setSize(980, 720);
		setTitle("Kriptografija v1.37");
		setResizable(true);
		setLocationRelativeTo(null);
		setLayout(new BorderLayout());
							
		/*RASPORED KOMPONENTI*/
		
		/*LEVO*/
		jTabbedPaneLevo.setBorder(BorderFactory.createEtchedBorder());
		add(jTabbedPaneLevo, null);

		//TAB-VIGENER
		jPanelTabVigener.setBorder(BorderFactory.createEtchedBorder());
		jPanelTabVigener.setLayout(new BoxLayout(jPanelTabVigener, BoxLayout.Y_AXIS));
		jTabbedPaneLevo.add(jPanelTabVigener, "Vigener");
		
		jPanelTekst.setBorder(BorderFactory.createEtchedBorder());
		jPanelTekst.setLayout(new BorderLayout());
		jPanelTekst.setPreferredSize(new Dimension(0, 2048));		
		jTextAreaTekst.setText(""); 
		jTextAreaTekst.setEditable(false);
		jScrollPaneTekst.getViewport().add(jTextAreaTekst, null);
		jPanelTekst.add(jScrollPaneTekst, BorderLayout.CENTER);
		jPanelTekstInfo.setBorder(BorderFactory.createEtchedBorder());
		jPanelTekstInfo.setLayout(new BoxLayout(jPanelTekstInfo, BoxLayout.Y_AXIS));
		jPanelTekstInfo.setPreferredSize(new Dimension(250,0));
		jTextAreaTekstInfo.setText(""); 
		jTextAreaTekstInfo.setEditable(false);
		jScrollPaneTekstInfo.getViewport().add(jTextAreaTekstInfo, null);
		jPanelTekstInfo.add(jScrollPaneTekstInfo, null);
		jPanelTekst.add(jPanelTekstInfo, BorderLayout.EAST);
		jPanelTabVigener.add(jPanelTekst, BorderLayout.NORTH);
		
		jPanelCentar.setBorder(BorderFactory.createEtchedBorder());
		jPanelCentar.setLayout(new FlowLayout());
		jPanelTabVigener.add(jPanelCentar, BorderLayout.CENTER);
		jLabelTekst.setText("Tekst Gore:");
		jPanelCentar.add(jLabelTekst, null);
		jButtonTekstDodaj.setText("Ucitaj");
		jButtonTekstDodaj.addActionListener(this);
		jPanelCentar.add(jButtonTekstDodaj, null);
		jButtonTekstSifrat.setText("Sifruj");
		jButtonTekstSifrat.addActionListener(this);
		jPanelCentar.add(jButtonTekstSifrat, null);
		jButtonTekstSnimi.setText("Snimi");
		jButtonTekstSnimi.addActionListener(this);
		jPanelCentar.add(jButtonTekstSnimi, null);		
		jButtonTekstBrisi.setText("Brisi");
		jButtonTekstBrisi.addActionListener(this);
		jPanelCentar.add(jButtonTekstBrisi, null);	
		jLabelKljuc.setText(" Kljuc:");
		jPanelCentar.add(jLabelKljuc, null);
		jTextFieldKljuc.setText("kljuc");
		jTextFieldKljuc.setPreferredSize(new Dimension(200,20));
		jPanelCentar.add(jTextFieldKljuc, null);
		jLabelSifrat.setText("Sifrat Dole:");
		jPanelCentar.add(jLabelSifrat, null);		
		jButtonSifratDodaj.setText("Ucitaj");
		jButtonSifratDodaj.addActionListener(this);
		jPanelCentar.add(jButtonSifratDodaj, null);
		jButtonSifratTekst.setText("Desifruj");
		jButtonSifratTekst.addActionListener(this);
		jPanelCentar.add(jButtonSifratTekst, null);
		jButtonSifratSnimi.setText("Snimi");
		jButtonSifratSnimi.addActionListener(this);
		jPanelCentar.add(jButtonSifratSnimi, null);		
		jButtonSifratBrisi.setText("Brisi");
		jButtonSifratBrisi.addActionListener(this);
		jPanelCentar.add(jButtonSifratBrisi, null);		

		jPanelSifrat.setBorder(BorderFactory.createEtchedBorder());
		jPanelSifrat.setLayout(new BorderLayout());
		jPanelSifrat.setPreferredSize(new Dimension(0, 2048));		
		jTextAreaSifrat.setText(""); 
		jTextAreaSifrat.setEditable(false);
		jScrollPaneSifrat.getViewport().add(jTextAreaSifrat, null);
		jPanelSifrat.add(jScrollPaneSifrat, BorderLayout.CENTER);
		jPanelSifratInfo.setBorder(BorderFactory.createEtchedBorder());
		jPanelSifratInfo.setLayout(new BoxLayout(jPanelSifratInfo, BoxLayout.Y_AXIS));
		jPanelSifratInfo.setPreferredSize(new Dimension(250,0));
		jTextAreaSifratInfo.setText(""); 
		jTextAreaSifratInfo.setEditable(false);
		jScrollPaneSifratInfo.getViewport().add(jTextAreaSifratInfo, null);
		jPanelSifratInfo.add(jScrollPaneSifratInfo, null);
		jPanelSifrat.add(jPanelSifratInfo, BorderLayout.EAST);
		jPanelTabVigener.add(jPanelSifrat, BorderLayout.SOUTH);		
		
		//TAB-ANALIZA
		jPanelTabAnaliza.setBorder(BorderFactory.createEtchedBorder());
		jPanelTabAnaliza.setLayout(new BorderLayout());
		jTabbedPaneLevo.add(jPanelTabAnaliza, "Analiza");
		
		jPanelRezultati.setBorder(BorderFactory.createEtchedBorder());
		jPanelRezultati.setLayout(new BorderLayout());
		jPanelRezultati.setPreferredSize(new Dimension(0, 2048));
		jTextAreaRezultati.setText(""); 
		jTextAreaRezultati.setEditable(false);
		jScrollPaneRezultati.getViewport().add(jTextAreaRezultati, null);
		jPanelRezultati.add(jScrollPaneRezultati, BorderLayout.CENTER);
		jPanelTabAnaliza.add(jPanelRezultati, BorderLayout.CENTER);
		
		jPanelUpravljanje.setBorder(BorderFactory.createEtchedBorder());
		jPanelUpravljanje.setLayout(new VerticalFlowLayout());
		jPanelUpravljanje.setPreferredSize(new Dimension(150,0));
		jPanelTabAnaliza.add(jPanelUpravljanje, BorderLayout.EAST);
		jLabelOpseg.setText("Opseg:");
		jPanelUpravljanje.add(jLabelOpseg, null);
		jPanelOpseg.setLayout(new BoxLayout(jPanelOpseg, BoxLayout.X_AXIS));
		jPanelUpravljanje.add(jPanelOpseg, null);
		jTextFieldOpseg1.setText("1");
		jPanelOpseg.add(jTextFieldOpseg1, null);
		jTextFieldOpseg2.setText("10");
		jPanelOpseg.add(jTextFieldOpseg2, null);
		jButtonDuzina.setText("Duzina");
		jButtonDuzina.addActionListener(this);
		jPanelUpravljanje.add(jButtonDuzina, null);
		jTextFieldDuzina.setText("");
		jPanelUpravljanje.add(jTextFieldDuzina, null);
		jButtonKljuc.setText("Kljuc");
		jButtonKljuc.addActionListener(this);
		jPanelUpravljanje.add(jButtonKljuc, null);
		jLabelRezultatKljuc.setText("Rezultat:");
		jPanelUpravljanje.add(jLabelRezultatKljuc, null);
		jTextFieldRezultatKljuc.setText("");
		jTextFieldRezultatKljuc.setFont(new Font("Monospaced", Font.PLAIN, 12));		
		jPanelUpravljanje.add(jTextFieldRezultatKljuc, null);		
		jComboBoxRezultatKljuc1.setPreferredSize(new Dimension(0, 16));
		jComboBoxRezultatKljuc1.addItemListener(this);
		jPanelUpravljanje.add(jComboBoxRezultatKljuc1, null);
		jComboBoxRezultatKljuc2.setPreferredSize(new Dimension(0, 16));		
		jComboBoxRezultatKljuc2.addItemListener(this);		
		jPanelUpravljanje.add(jComboBoxRezultatKljuc2, null);
		jComboBoxRezultatKljuc3.setPreferredSize(new Dimension(0, 16));
		jComboBoxRezultatKljuc3.addItemListener(this);
		jPanelUpravljanje.add(jComboBoxRezultatKljuc3, null);
		jComboBoxRezultatKljuc4.setPreferredSize(new Dimension(0, 16));
		jComboBoxRezultatKljuc4.addItemListener(this);		
		jPanelUpravljanje.add(jComboBoxRezultatKljuc4, null);
		jComboBoxRezultatKljuc5.setPreferredSize(new Dimension(0, 16));
		jComboBoxRezultatKljuc5.addItemListener(this);		
		jPanelUpravljanje.add(jComboBoxRezultatKljuc5, null);
		jComboBoxRezultatKljuc6.setPreferredSize(new Dimension(0, 16));
		jComboBoxRezultatKljuc6.addItemListener(this);		
		jPanelUpravljanje.add(jComboBoxRezultatKljuc6, null);
		jComboBoxRezultatKljuc7.setPreferredSize(new Dimension(0, 16));
		jComboBoxRezultatKljuc7.addItemListener(this);		
		jPanelUpravljanje.add(jComboBoxRezultatKljuc7, null);
		jComboBoxRezultatKljuc8.setPreferredSize(new Dimension(0, 16));
		jComboBoxRezultatKljuc8.addItemListener(this);		
		jPanelUpravljanje.add(jComboBoxRezultatKljuc8, null);
		jComboBoxRezultatKljuc9.setPreferredSize(new Dimension(0, 16));
		jComboBoxRezultatKljuc9.addItemListener(this);		
		jPanelUpravljanje.add(jComboBoxRezultatKljuc9, null);
		jComboBoxRezultatKljuc10.setPreferredSize(new Dimension(0, 16));
		jComboBoxRezultatKljuc10.addItemListener(this);		
		jPanelUpravljanje.add(jComboBoxRezultatKljuc10, null);
		jComboBoxRezultatKljuc11.setPreferredSize(new Dimension(0, 16));
		jComboBoxRezultatKljuc11.addItemListener(this);		
		jPanelUpravljanje.add(jComboBoxRezultatKljuc11, null);
		jComboBoxRezultatKljuc12.setPreferredSize(new Dimension(0, 16));
		jComboBoxRezultatKljuc12.addItemListener(this);		
		jPanelUpravljanje.add(jComboBoxRezultatKljuc12, null);
		jComboBoxRezultatKljuc13.setPreferredSize(new Dimension(0, 16));
		jComboBoxRezultatKljuc13.addItemListener(this);		
		jPanelUpravljanje.add(jComboBoxRezultatKljuc13, null);
		jComboBoxRezultatKljuc14.setPreferredSize(new Dimension(0, 16));
		jComboBoxRezultatKljuc14.addItemListener(this);		
		jPanelUpravljanje.add(jComboBoxRezultatKljuc14, null);
		jComboBoxRezultatKljuc15.setPreferredSize(new Dimension(0, 16));
		jComboBoxRezultatKljuc15.addItemListener(this);		
		jPanelUpravljanje.add(jComboBoxRezultatKljuc15, null);
		jComboBoxRezultatKljuc16.setPreferredSize(new Dimension(0, 16));
		jComboBoxRezultatKljuc16.addItemListener(this);		
		jPanelUpravljanje.add(jComboBoxRezultatKljuc16, null);
		jComboBoxRezultatKljuc1.setPreferredSize(new Dimension(0, 16));
		jTextAreaRezultatKljucevi.setText("");
		jTextAreaRezultatKljucevi.setEditable(false);
		jTextAreaRezultatKljucevi.setPreferredSize(new Dimension(0, 100));
		jTextAreaRezultatKljucevi.setFont(new Font("Monospaced", Font.PLAIN, 12));
		jScrollPaneRezultatKljucevi.getViewport().add(jTextAreaRezultatKljucevi, null);		
		//jPanelUpravljanje.add(jScrollPaneRezultatKljucevi, null);
		jLabelTest.setText("Test:");
		jPanelUpravljanje.add(jLabelTest, null);
		jButtonUporedi.setText("Uporedi");
		jButtonUporedi.addActionListener(this);
		jPanelUpravljanje.add(jButtonUporedi, null);		
		jButtonBrisi.setText("Brisi");
		jButtonBrisi.addActionListener(this);
		jPanelUpravljanje.add(jButtonBrisi, null);		
	
		/*DNO*/
		jPanelDno.setBorder(BorderFactory.createEtchedBorder());
		jPanelDno.setLayout(new BorderLayout());
		add(jPanelDno, BorderLayout.SOUTH);
		jPanelKontrola.setLayout(new FlowLayout());
		jPanelDno.add(jPanelKontrola, BorderLayout.WEST);			
		jButtonNotepad.setText("Notepad");
		jButtonNotepad.addActionListener(this);
		jPanelKontrola.add(jButtonNotepad, null);		
		jButtonJezik.setText("Jezik");
		jButtonJezik.addActionListener(this);
		jPanelKontrola.add(jButtonJezik, null);				
		jLabelJezik.setText("");
		jPanelDno.add(jLabelJezik, BorderLayout.CENTER);		
		jProgressBar.setPreferredSize(new Dimension(300,0));
		jPanelDno.add(jProgressBar, BorderLayout.EAST);		
		
		initialize();
		setVisible(true);    		
	}

	public void actionPerformed(ActionEvent ae) {
		String command = ae.getActionCommand();
		Object source = ae.getSource();

		if (command.equals("Jezik")) {
			int status;
			
			jFileChooser.setDialogTitle("Odaberite definiciju jezika");
			jFileChooser.setApproveButtonText("Otvori");
			try {jFileChooser.setCurrentDirectory(new File(((new File(".")).getCanonicalPath())+"\\#jezici"));} catch (IOException e) {}			
			jFileChooser.addChoosableFileFilter(fileFilterTxt);
			
			status = jFileChooser.showOpenDialog(this);
			if (status == JFileChooser.APPROVE_OPTION) {					
				opis_jezika = jFileChooser.getSelectedFile();
				tekst = new Dokument(opis_jezika, "UTF-16");							
				sifrat = new Dokument(opis_jezika, "UTF-16");
				kljuc = null;
			}		
			
			jFileChooser.setDialogTitle("Odaberite tipican tekst");
			jFileChooser.setApproveButtonText("Otvori");
			try {jFileChooser.setCurrentDirectory(new File(((new File(".")).getCanonicalPath())+"\\#jezici"));} catch (IOException e) {}			
			jFileChooser.addChoosableFileFilter(fileFilterTxt);
			
			status = jFileChooser.showOpenDialog(this);
			if (status == JFileChooser.APPROVE_OPTION) {					
				tipican_dokument = new Dokument(opis_jezika, "UTF-16");
				tipican_dokument.dodajTekst(jFileChooser.getSelectedFile());
			}			
		}

		if (command.equals("Notepad")) {
			try {
				Runtime.getRuntime().exec("\"notepad.exe\"");
			} catch (IOException ioException) {

			} 
		} else {
			if ((tekst != null) && (sifrat != null)) {
				
				if (command.equals("Ucitaj")) {
					if (source.equals(jButtonTekstDodaj)) {
						jFileChooser.setDialogTitle("Odaberite tekst");
						jFileChooser.setApproveButtonText("Otvori");
						try {jFileChooser.setCurrentDirectory(new File(((new File(".")).getCanonicalPath())+"\\#dokumenti"));} catch (IOException e) {}			
						jFileChooser.addChoosableFileFilter(fileFilterTxt);
						
						int status;
						status = jFileChooser.showOpenDialog(this);
						if (status == JFileChooser.APPROVE_OPTION) {					
							File file = jFileChooser.getSelectedFile();
							tekst = new Dokument(opis_jezika, "UTF-16");
							tekst.dodajTekst(file);
						}
					}
				}
			
				if (command.equals("Sifruj")) {
	            	SwingWorker worker = new SwingWorker() {
	                	public Object construct() {
	                		sifrat = tekst.viznerovoSifrovanje(jTextFieldKljuc.getText(), true, jProgressBar);
	                		kljuc = null;
		                	return null;
	                	}
	                	public void finished() {
	                		initialize();
		                }
	            	};
	            	worker.start();				
				}
				
				if (command.equals("Snimi")) {
					if (source.equals(jButtonTekstSnimi)) {
					
						jFileChooser.setDialogTitle("Snimite tekst");
						jFileChooser.setApproveButtonText("Snimi");
						try {jFileChooser.setCurrentDirectory(new File(((new File(".")).getCanonicalPath())+"\\#dokumenti"));} catch (IOException e) {}			
						jFileChooser.addChoosableFileFilter(fileFilterTxt);
						
						int status;
						status = jFileChooser.showSaveDialog(this);
						if (status == JFileChooser.APPROVE_OPTION) {					
							File file = jFileChooser.getSelectedFile();
							tekst.toFile(file, "UTF-16");
						}
					}
				}				
				
				if (command.equals("Brisi")) {
					if (source.equals(jButtonTekstBrisi)) {
						tekst = new Dokument(opis_jezika, "UTF-16");				
					}
				}				
			
				if (command.equals("Ucitaj")) {
					if (source.equals(jButtonSifratDodaj)) {
						jFileChooser.setDialogTitle("Odaberite sifrat");
						jFileChooser.setApproveButtonText("Otvori");
						try {jFileChooser.setCurrentDirectory(new File(((new File(".")).getCanonicalPath())+"\\#dokumenti"));} catch (IOException e) {}			
						jFileChooser.addChoosableFileFilter(fileFilterTxt);
						
						int status;
						status = jFileChooser.showOpenDialog(this);
						if (status == JFileChooser.APPROVE_OPTION) {					
							File file = jFileChooser.getSelectedFile();
							sifrat = new Dokument(opis_jezika, "UTF-16");
							sifrat.dodajTekst(file);
							kljuc = null;
						}
					}
				}
			
				if (command.equals("Desifruj")) {
	            	SwingWorker worker = new SwingWorker() {
	                	public Object construct() {
	                		tekst = sifrat.viznerovoSifrovanje(jTextFieldKljuc.getText(), false, jProgressBar);
		                	return null;
	                	}
	                	public void finished() {
	                		initialize();
		                }
	            	};
		            worker.start();				
				}	
				
				if (command.equals("Snimi")) {
					if (source.equals(jButtonSifratSnimi)) {
					
						jFileChooser.setDialogTitle("Snimite tekst");
						jFileChooser.setApproveButtonText("Snimi");
						try {jFileChooser.setCurrentDirectory(new File(((new File(".")).getCanonicalPath())+"\\#dokumenti"));} catch (IOException e) {}			
						jFileChooser.addChoosableFileFilter(fileFilterTxt);
						
						int status;
						status = jFileChooser.showSaveDialog(this);
						if (status == JFileChooser.APPROVE_OPTION) {					
							File file = jFileChooser.getSelectedFile();
							sifrat.toFile(file, "UTF-16");
						}
					}
				}
				
				if (command.equals("Brisi")) {
					if (source.equals(jButtonSifratBrisi)) {
						sifrat = new Dokument(opis_jezika, "UTF-16");	
						kljuc = null;
					}
				}				
				
				if (command.equals("Duzina")) {
					String str_opseg1, str_opseg2; 
					int int_opseg1, int_opseg2;
					
					try {
						str_opseg1 = jTextFieldOpseg1.getText();
						int_opseg1 = Integer.parseInt(str_opseg1.trim());
						
						str_opseg2 = jTextFieldOpseg2.getText();
						int_opseg2 = Integer.parseInt(str_opseg2.trim());					
					} catch (NumberFormatException nfe) {
						int_opseg1 = 1;
						jTextFieldOpseg1.setText(int_opseg1 + "");
						
						int_opseg2 = 10;
						jTextFieldOpseg2.setText(int_opseg2 + "");
					}

					double indeksi[][] = sifrat.odrediIndekseKoincidencije(int_opseg1, int_opseg2);
					String s = "";
					String red;
					for (int i = 0; i < indeksi.length; i++) {
						red = int_opseg1 + i + "";
						while (red.length() < 2) {
							red = "0" + red;
						}					
						
						s += "[" + red + "] ";
						for (int j = 0; j < indeksi[i].length; j++) {
							s += Dokument.doubleToString(indeksi[i][j], Dokument.IK) + "   ";
						}
						s += "\n";
					}
					jTextAreaRezultati.setText(s);
					
					jTextFieldDuzina.setText(sifrat.pretpostaviDuzinuViznerovogKljuca(int_opseg1, int_opseg2, tipican_dokument, 1) + "");
				}			
			
				if (command.equals("Kljuc")) {
					String str_duzina; 
					int int_duzina;	
								
					try {
						str_duzina = jTextFieldDuzina.getText();
						int_duzina = Integer.parseInt(str_duzina.trim());					
					} catch (NumberFormatException nfe) {
						int_duzina = 0;
						jTextFieldDuzina.setText(int_duzina + "");
					}			
	
					kljuc = sifrat.pretpostaviVizenrovKljuc(int_duzina, tipican_dokument);
					
					popuniCombo();
					popuniKljuc();
				}			
				
				if (command.equals("Uporedi")) {
					String generisani_kljuc;
					Dokument _tekst;
	
					generisani_kljuc = jTextFieldRezultatKljuc.getText();
					_tekst = sifrat.viznerovoSifrovanje(generisani_kljuc, false, jProgressBar);
					
					if (tekst.uporediDokument(_tekst) == true) {
						JOptionPane.showMessageDialog(this, "Generisani kljuc je ispravan!");
					} else {
						JOptionPane.showMessageDialog(this, "Generisani kljuc nije ispravan ili ucitani originalni dokument nije vazeci!");
					}
				}
				
				if (command.equals("Brisi")) {
					if (source.equals(jButtonBrisi)) {					
						
						kljuc = null;
						
						jTextAreaRezultati.setText("");
						jTextFieldDuzina.setText("");
						jTextFieldKljuc.setText("");						
						
						popuniCombo();
					}
				}
				
			} else {
				JOptionPane.showMessageDialog(this, "Jezik nije definisan!");				
			}		
		}
			
		initialize();
	}
	
	public void itemStateChanged(ItemEvent arg0) {
		if (((JComboBox)arg0.getSource()).getItemCount() >= 0) {
			popuniKljuc();
		}
	}	
		
	private void initialize() {
		jLabelJezik.setText("");
		if (opis_jezika != null) {
			jLabelJezik.setText("  [" + tipican_dokument.nazivJezika() + "]");
		}
		
		jTextAreaTekst.setText("");
		jTextAreaTekstInfo.setText("");		
		if (tekst != null) {
			jTextAreaTekst.setText(tekst.toString());
			jTextAreaTekst.setCaretPosition(0);
			if (tekst.duzina() > 0) {
				jTextAreaTekstInfo.setText(tekst.toInfo() + "\n\n" + tekst.toStatistics());
			} else {
				jTextAreaTekstInfo.setText("");
			}
			jTextAreaTekstInfo.setCaretPosition(0);
		}
		
		jTextAreaSifrat.setText("");
		jTextAreaSifratInfo.setText("");		
		if (sifrat != null) {
			jTextAreaSifrat.setText(sifrat.toString());
			jTextAreaSifrat.setCaretPosition(0);
			if (sifrat.duzina() > 0) {
				jTextAreaSifratInfo.setText(sifrat.toInfo() + "\n\n" + sifrat.toStatistics());
			} else {
				jTextAreaSifratInfo.setText("");
			}
			jTextAreaSifratInfo.setCaretPosition(0);
		}
	}
	
	public void popuniCombo() {
		
		jComboBoxRezultatKljuc1.removeAllItems();
		jComboBoxRezultatKljuc2.removeAllItems();
		jComboBoxRezultatKljuc3.removeAllItems();
		jComboBoxRezultatKljuc4.removeAllItems();
		jComboBoxRezultatKljuc5.removeAllItems();
		jComboBoxRezultatKljuc6.removeAllItems();
		jComboBoxRezultatKljuc7.removeAllItems();
		jComboBoxRezultatKljuc8.removeAllItems();
		jComboBoxRezultatKljuc9.removeAllItems();
		jComboBoxRezultatKljuc10.removeAllItems();
		jComboBoxRezultatKljuc11.removeAllItems();
		jComboBoxRezultatKljuc12.removeAllItems();
		jComboBoxRezultatKljuc13.removeAllItems();
		jComboBoxRezultatKljuc14.removeAllItems();
		jComboBoxRezultatKljuc15.removeAllItems();
		jComboBoxRezultatKljuc16.removeAllItems();
				
		if (kljuc != null) {
		
			if (kljuc[0].length >= 1) {			
				for (int k = 0; k < kljuc[0][1-1].length; k++) {				
					jComboBoxRezultatKljuc1.addItem(kljuc[0][1-1][k] + " " + Dokument.doubleToString(((BigDecimal)kljuc[1][1-1][k]).doubleValue(), Dokument.IK));
				}
			}
			if (kljuc[0].length >= 2) {			
				for (int k = 0; k < kljuc[0][2-1].length; k++) {				
					jComboBoxRezultatKljuc2.addItem(kljuc[0][2-1][k] + " " + Dokument.doubleToString(((BigDecimal)kljuc[1][2-1][k]).doubleValue(), Dokument.IK));
				}
			}			
			if (kljuc[0].length >= 3) {			
				for (int k = 0; k < kljuc[0][3-1].length; k++) {				
					jComboBoxRezultatKljuc3.addItem(kljuc[0][3-1][k] + " " + Dokument.doubleToString(((BigDecimal)kljuc[1][3-1][k]).doubleValue(), Dokument.IK));
				}
			}
			if (kljuc[0].length >= 4) {			
				for (int k = 0; k < kljuc[0][4-1].length; k++) {				
					jComboBoxRezultatKljuc4.addItem(kljuc[0][4-1][k] + " " + Dokument.doubleToString(((BigDecimal)kljuc[1][4-1][k]).doubleValue(), Dokument.IK));
				}
			}
			if (kljuc[0].length >= 5) {			
				for (int k = 0; k < kljuc[0][5-1].length; k++) {				
					jComboBoxRezultatKljuc5.addItem(kljuc[0][5-1][k] + " " + Dokument.doubleToString(((BigDecimal)kljuc[1][5-1][k]).doubleValue(), Dokument.IK));
				}
			}
			if (kljuc[0].length >= 6) {			
				for (int k = 0; k < kljuc[0][6-1].length; k++) {				
					jComboBoxRezultatKljuc6.addItem(kljuc[0][6-1][k] + " " + Dokument.doubleToString(((BigDecimal)kljuc[1][6-1][k]).doubleValue(), Dokument.IK));
				}
			}
			if (kljuc[0].length >= 7) {			
				for (int k = 0; k < kljuc[0][7-1].length; k++) {				
					jComboBoxRezultatKljuc7.addItem(kljuc[0][7-1][k] + " " + Dokument.doubleToString(((BigDecimal)kljuc[1][7-1][k]).doubleValue(), Dokument.IK));
				}
			}
			if (kljuc[0].length >= 8) {			
				for (int k = 0; k < kljuc[0][8-1].length; k++) {				
					jComboBoxRezultatKljuc8.addItem(kljuc[0][8-1][k] + " " + Dokument.doubleToString(((BigDecimal)kljuc[1][8-1][k]).doubleValue(), Dokument.IK));
				}
			}
			if (kljuc[0].length >= 9) {			
				for (int k = 0; k < kljuc[0][9-1].length; k++) {				
					jComboBoxRezultatKljuc9.addItem(kljuc[0][9-1][k] + " " + Dokument.doubleToString(((BigDecimal)kljuc[1][9-1][k]).doubleValue(), Dokument.IK));
				}
			}
			if (kljuc[0].length >= 10) {			
				for (int k = 0; k < kljuc[0][10-1].length; k++) {				
					jComboBoxRezultatKljuc10.addItem(kljuc[0][10-1][k] + " " + Dokument.doubleToString(((BigDecimal)kljuc[1][10-1][k]).doubleValue(), Dokument.IK));
				}
			}
			if (kljuc[0].length >= 11) {			
				for (int k = 0; k < kljuc[0][11-1].length; k++) {				
					jComboBoxRezultatKljuc11.addItem(kljuc[0][11-1][k] + " " + Dokument.doubleToString(((BigDecimal)kljuc[1][11-1][k]).doubleValue(), Dokument.IK));
				}
			}
			if (kljuc[0].length >= 12) {			
				for (int k = 0; k < kljuc[0][12-1].length; k++) {				
					jComboBoxRezultatKljuc12.addItem(kljuc[0][12-1][k] + " " + Dokument.doubleToString(((BigDecimal)kljuc[1][12-1][k]).doubleValue(), Dokument.IK));
				}
			}
			if (kljuc[0].length >= 13) {			
				for (int k = 0; k < kljuc[0][13-1].length; k++) {				
					jComboBoxRezultatKljuc13.addItem(kljuc[0][13-1][k] + " " + Dokument.doubleToString(((BigDecimal)kljuc[1][13-1][k]).doubleValue(), Dokument.IK));
				}
			}
			if (kljuc[0].length >= 14) {			
				for (int k = 0; k < kljuc[0][14-1].length; k++) {				
					jComboBoxRezultatKljuc14.addItem(kljuc[0][14-1][k] + " " + Dokument.doubleToString(((BigDecimal)kljuc[1][14-1][k]).doubleValue(), Dokument.IK));
				}
			}
			if (kljuc[0].length >= 15) {			
				for (int k = 0; k < kljuc[0][15-1].length; k++) {				
					jComboBoxRezultatKljuc15.addItem(kljuc[0][15-1][k] + " " + Dokument.doubleToString(((BigDecimal)kljuc[1][15-1][k]).doubleValue(), Dokument.IK));
				}
			}
			if (kljuc[0].length >= 16) {			
				for (int k = 0; k < kljuc[0][16-1].length; k++) {				
					jComboBoxRezultatKljuc16.addItem(kljuc[0][16-1][k] + " " + Dokument.doubleToString(((BigDecimal)kljuc[1][16-1][k]).doubleValue(), Dokument.IK));
				}
			}			
		}
	}
	
	public void popuniKljuc() {
		String generisani_kljuc = "";
		int izbor;
		int duzina;
		
		if (kljuc != null) {
			duzina = kljuc[0].length;
			
			izbor = jComboBoxRezultatKljuc1.getSelectedIndex(); 
			if ((izbor >= 0) & (1 <= duzina)) {
				generisani_kljuc += kljuc[0][0][izbor];			
			}
			izbor = jComboBoxRezultatKljuc2.getSelectedIndex(); 
			if ((izbor >= 0) & (2 <= duzina)) {
				generisani_kljuc += kljuc[0][1][izbor];			
			}
			izbor = jComboBoxRezultatKljuc3.getSelectedIndex(); 
			if ((izbor >= 0) & (3 <= duzina)) {
				generisani_kljuc += kljuc[0][2][izbor];			
			}
			izbor = jComboBoxRezultatKljuc4.getSelectedIndex(); 
			if ((izbor >= 0) & (4 <= duzina)) {
				generisani_kljuc += kljuc[0][3][izbor];			
			}
			izbor = jComboBoxRezultatKljuc5.getSelectedIndex(); 
			if ((izbor >= 0) & (5 <= duzina)) {
				generisani_kljuc += kljuc[0][4][izbor];			
			}
			izbor = jComboBoxRezultatKljuc6.getSelectedIndex(); 
			if ((izbor >= 0) & (6 <= duzina)) {
				generisani_kljuc += kljuc[0][5][izbor];			
			}
			izbor = jComboBoxRezultatKljuc7.getSelectedIndex(); 
			if ((izbor >= 0) & (7 <= duzina)) {
				generisani_kljuc += kljuc[0][6][izbor];			
			}
			izbor = jComboBoxRezultatKljuc8.getSelectedIndex(); 
			if ((izbor >= 0) & (8 <= duzina)) {
				generisani_kljuc += kljuc[0][7][izbor];			
			}
			izbor = jComboBoxRezultatKljuc9.getSelectedIndex(); 
			if ((izbor >= 0) & (9 <= duzina)) {
				generisani_kljuc += kljuc[0][8][izbor];			
			}
			izbor = jComboBoxRezultatKljuc10.getSelectedIndex(); 
			if ((izbor >= 0) & (10 <= duzina)) {
				generisani_kljuc += kljuc[0][9][izbor];			
			}
			izbor = jComboBoxRezultatKljuc11.getSelectedIndex(); 
			if ((izbor >= 0) & (11 <= duzina)) {
				generisani_kljuc += kljuc[0][10][izbor];			
			}
			izbor = jComboBoxRezultatKljuc12.getSelectedIndex(); 
			if ((izbor >= 0) & (12 <= duzina)) {
				generisani_kljuc += kljuc[0][11][izbor];			
			}
			izbor = jComboBoxRezultatKljuc13.getSelectedIndex(); 
			if ((izbor >= 0) & (13 <= duzina)) {
				generisani_kljuc += kljuc[0][12][izbor];			
			}
			izbor = jComboBoxRezultatKljuc14.getSelectedIndex(); 
			if ((izbor >= 0) & (14 <= duzina)) {
				generisani_kljuc += kljuc[0][13][izbor];			
			}
			izbor = jComboBoxRezultatKljuc15.getSelectedIndex(); 
			if ((izbor >= 0) & (15 <= duzina)) {
				generisani_kljuc += kljuc[0][14][izbor];			
			}
			izbor = jComboBoxRezultatKljuc16.getSelectedIndex(); 
			if ((izbor >= 0) & (16 <= duzina)) {
				generisani_kljuc += kljuc[0][15][izbor];			
			}
		}	
		
		jTextFieldRezultatKljuc.setText(generisani_kljuc);
	}
	
	//WINDOW LISTENER
	WindowListener wl = new WindowAdapter() {
		public void windowClosing(WindowEvent we) {
			System.exit(0);
		}
	};
   
	//ACTION LISTENER (TIMER)
	ActionListener al = new ActionListener() {
		public void actionPerformed(ActionEvent ae) {
			if (tekst != null) {
			   
			}
		}
	};   

	//FILE FILTER (txt)
	FileFilter fileFilterTxt = new FileFilter() {
		public boolean accept(File file) {
			if (file.getPath().contains(".txt") || file.isDirectory()) return true; else return false; 
		}

		public String getDescription() {
			return "*.txt";
		}
	};   

	public static void main(String[] args) {	
		new GUI();
	}    
}
